<?php

namespace STM\Competition;

use \Exception;
use \GetterOfTestingInstances;
use STM\StmFactory;

/**
 * Test class for CompetitionValidator.
 * Generated by PHPUnit on 2011-08-27 at 12:26:05.
 * @group competition
 */
class CompetitionValidatorTest extends \PHPUnit_Framework_TestCase {

    private $bad_values;
    private $competitions;

    protected function setUp() {
        $this->bad_values = array('', null, false, array(), new Exception());
        $this->competitions = GetterOfTestingInstances::find_competitions();
    }

    public function testCheck_create() {
        foreach ($this->bad_values as $value) {
            CompetitionValidator::init();
            $this->assertFalse(CompetitionValidator::checkCreate($value));
        }
        CompetitionValidator::init();
        $dates = array('name' => 'dsadsadsa', 'match_periods' => 2, 'date_start' => 'today', 'date_end' => 'yesterday', 'id_score_type' => 'F', 'id_competition_type' => 'X', 'id_category' => null, 'id_status' => 'P');        
        $this->assert_bad_arguments('checkCreate', $dates);
        CompetitionValidator::init();
        $dates['date_start'] = 'yesterday';
        $dates['date_end'] = 'today';
        parent::assertTrue(CompetitionValidator::checkCreate($dates));
    }

    public function testCheck_update() {
        foreach ($this->competitions as $competition) {
            CompetitionValidator::setCompetition($competition);
            $valid = array(
                'name' => $competition->__toString(), 
                'match_periods' => $competition->getNumberOfMatchPeriods(), 
                'date_start' => $competition->getDateStart()->__toString(), 
                'date_end' => $competition->getEndStart()->__toString(), 
                'id_score_type' => $competition->getScoreType(), 
                'id_competition_type' => $competition->getIdCompetitionType(), 
                'id_category' => $competition->getIdCategory(), 
                'id_status' => $competition->getStatusId()
            );
            // different from current name and club
            $this->assert_bad_arguments('checkUpdate', $valid);
            
            // at least one change (in name or club)
            $valid['name'] .= '*x*';
            parent::assertTrue(CompetitionValidator::checkUpdate($valid));
            
            CompetitionValidator::resetCompetition();
        }
    }

    public function testCheck_score_type() {
        CompetitionValidator::init(); // new init, otherwise errors from previous test
        // OK        
        parent::assertTrue(CompetitionValidator::checkScoreType('F'));
        parent::assertTrue(CompetitionValidator::checkScoreType('T'));
        // BAD
        foreach ($this->bad_values as $value) {
            $this->assert_bad_arguments('checkScoreType', $value);
        }
    }

    public function testCheck_match_periods() {
        CompetitionValidator::init();
        parent::assertTrue(CompetitionValidator::checkMatchPeriods(1));
        parent::assertTrue(CompetitionValidator::checkMatchPeriods(1.1));
        // true, but save to database as 1 - (int) 1.1
        parent::assertTrue(CompetitionValidator::checkMatchPeriods(5));
        parent::assertTrue(CompetitionValidator::checkMatchPeriods(10));

        foreach ($this->bad_values as $value) {
            $this->assert_bad_arguments('checkMatchPeriods', $value);
        }
    }

    public function testCheck_name() {
        CompetitionValidator::init();
        parent::assertTrue(CompetitionValidator::checkName('dsadsa'));
        parent::assertTrue(CompetitionValidator::checkName('XTAZU    '));

        foreach ($this->bad_values as $value) {
            $this->assert_bad_arguments('checkName', $value);
        }
    }

    public function testCheck_date_start() {
        CompetitionValidator::init();
        parent::assertTrue(CompetitionValidator::checkDateStart('today'));
        parent::assertTrue(CompetitionValidator::checkDateStart('1.1.2011'));
        parent::assertTrue(CompetitionValidator::checkDateStart('1.1.2011 - 21 years'));

        foreach ($this->competitions as $competition) {
            CompetitionValidator::init();
            CompetitionValidator::setCompetition($competition);
            if ($competition->getEndStart()->isValid() && $competition->getDateStart()->isValid()) {
                // FAIL - bigger than end date
                $this->assert_bad_arguments('checkDateStart', "{$competition->getEndStart()->__toString()} + 1 year");
                // OK - same as end date   
                CompetitionValidator::init();
                parent::assertTrue(CompetitionValidator::checkDateStart($competition->getEndStart()->__toString()));
            }
        }
        CompetitionValidator::resetCompetition();
    }

    public function testCheck_date_end() {
        CompetitionValidator::init();
        parent::assertTrue(CompetitionValidator::checkDateEnd('today'));
        parent::assertTrue(CompetitionValidator::checkDateEnd('1.1.2011'));
        parent::assertTrue(CompetitionValidator::checkDateEnd('1.1.2011 - 21 years'));
    }

    public function testCheck_category() {
        foreach ($this->bad_values as $value) {
            // id_category can be nonempty
            if (!empty($value)) {
                $this->assert_bad_arguments('checkCategory', $value);
            }
        }
    }

    public function testCheck_status() {
        CompetitionValidator::init(); // new init, otherwise errors from previous test
        CompetitionValidator::resetCompetition();
        // OK        
        parent::assertTrue(CompetitionValidator::checkStatus('P'));
        parent::assertTrue(CompetitionValidator::checkStatus('V'));
        parent::assertTrue(CompetitionValidator::checkStatus('H'));
        // BAD
        foreach ($this->bad_values as $value) {
            $this->assert_bad_arguments('checkStatus', $value);
        }
    }

    public function testCheck_added_team() {
        // competition must be set
        CompetitionValidator::resetCompetition();
        $this->assert_bad_arguments('checkAddedTeam', StmFactory::find()->Team->findById(1));
        // it must be instance of Team class
        $this->assert_bad_arguments('checkAddedTeam', null);
        // team cant be already in competition
        foreach ($this->competitions as $competition) {
            CompetitionValidator::setCompetition($competition);
            foreach ($competition->getTeams() as $team) {
                $this->assert_bad_arguments('checkAddedTeam', $team);
            }
            CompetitionValidator::resetCompetition();
        }
    }

    public function testCheck_competition_for_addTeams() {
        // competition must be set        
        CompetitionValidator::resetCompetition();
        $this->assert_bad_arguments('checkCompetitionForAddTeams', StmFactory::find()->Competition->findById(1));
        // it must be instance of Competition class        
        $this->assert_bad_arguments('checkCompetitionForAddTeams', null);
        // team cant be already in competition
        foreach ($this->competitions as $competition) {
            CompetitionValidator::setCompetition($competition);
            // it must be different competition
            $this->assert_bad_arguments('checkCompetitionForAddTeams', $competition);
            // at least one team in competition
            foreach ($this->competitions as $next_competition) {
                if ($next_competition->getCountTeams() == 0) {
                    $this->assert_bad_arguments('checkCompetitionForAddTeams', $next_competition);
                }
            }
            CompetitionValidator::resetCompetition();
        }
    }

    private function assert_bad_arguments($method, $data) {
        CompetitionValidator::init();
        parent::assertFalse(CompetitionValidator::$method($data));
        CompetitionValidator::init();
    }

}

?>